import traceback
import logging
from trans2es.models.topic import TopicTag, TopicImage, CommunityTopicProduct, Topic, CommunityCategoryTagRelation

from django.conf import settings
from trans2es.models.pictorial import PictorialTag
from random import randint
from trans2es.models.user_extra import UserExtra
from django.db import models


def get_edit_tag_id_list(topic_id):
    try:
        tag_id_list = TopicTag.objects.using(settings.SLAVE_DB_NAME).filter(topic_id=topic_id,
                                                                            is_collection=1).values_list("tag_id",
                                                                                                         flat=True)
        return tag_id_list
    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())
        return []


def topic_has_image(topic_id):
    try:
        has_image = False

        query_list = TopicImage.objects.using(settings.SLAVE_DB_NAME).filter(topic_id=topic_id, is_deleted=False,
                                                                             is_online=True)
        if len(query_list) > 0:
            has_image = True

        return has_image
    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())
        return False


def get_topic_product_info(topic_id):
    try:
        has_product = False

        query_list = CommunityTopicProduct.objects.using(settings.SLAVE_DB_NAME).filter(topic_id=topic_id,
                                                                                        is_deleted=False)
        if len(query_list) > 0:
            has_product = True

        return has_product
    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())
        return []


def get_pictorial_tag_by_id(pictorial_id):
    try:
        tag_id_list = list(
            PictorialTag.objects.filter(pictorial_id=pictorial_id, is_online=True, is_collection=1).values_list(
                "tag_id", flat=True))

        return tag_id_list
    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())
        return []


# def get_topic_data(numtime, numitme2):
#     try:
#
#         result_topic = Topic.objects.filter(create_time__lte=numitme2, create_time__gte=numtime,
#                                             is_online=True).values("user_id", "id")
#
#         if len(result_topic) > 0:
#             for i in result_topic:
#                 shadow_judge = UserExtra.objects.filter(user_id=i[0], is_online=Topic, is_deleted=False).values_list(
#                     "is_shadow", flat=True)
#
#         return shadow_judge
#     except:
#         logging.error("catch exception,err_msg:%s" % traceback.format_exc())
#         return []


def get_category_tag_id(edit_tag_list):
    try:
        logging.info("get -----------")
        # 拿到搜索的分类
        all_category_tag_list = CommunityCategoryTagRelation.objects.filter(tag_id__in=edit_tag_list, is_online=True,
                                                                            is_deleted=False).values_list(
            "category_tag_id", flat=True)
        ##去掉明星，品牌，其他的分类
        category_tag = []
        for i in all_category_tag_list:
            if i not in [707000, 348494, 18344]:
                category_tag.append(i)
        # 随机拿一个
        logging.info("get get_category_tag_id:%s" % category_tag)
        if len(category_tag) > 0:
            index = randint(0, len(category_tag) - 1)

            return category_tag[index]
        else:
            return 0

    except:
        logging.error("catch exception,err_msg:%s" % traceback.format_exc())
        return -1
